# OS-specific installation instructions for yle-dl

## Debian 10 (Buster)/Ubuntu 17.10

```
# If you have installed a previous version globally (without the
# --user switch in the pip install command), remove the globally
# installed version first:
sudo pip uninstall yle-dl

sudo apt-get install wget ffmpeg python3-dev python3-setuptools \
    python3-pip python3-requests python3-lxml
pip3 install --user --upgrade yle-dl
```


### Installing from source code on Debian 10/Ubuntu 17.10

```
# If you have installed a previous version globally (without the
# --user switch in the pip install command), remove the globally
# installed version first:
sudo pip uninstall yle-dl

sudo apt-get install git wget ffmpeg python3-dev python3-setuptools \
    python3-requests python3-lxml
git clone https://github.com/aajanki/yle-dl.git
cd yle-dl
python3 setup.py install --user
```


## Debian 9 (Stretch)/Ubuntu 16.04

```
# If you have installed a previous version globally (without the
# --user switch in the pip install command), remove the globally
# installed version first:
sudo pip uninstall yle-dl

sudo apt-get install wget ffmpeg python3-dev python3-setuptools \
    python3-pip python3-requests python3-lxml
pip3 install --user --upgrade yle-dl
```

(You may get prompted to upgrade pip. However, it is not necessary to
upgrade pip for installing yle-dl.)

### Installing from source code on Debian 9/Ubuntu 16.04

```
# If you have installed a previous version globally (without the
# --user switch in the pip install command), remove the globally
# installed version first:
sudo pip uninstall yle-dl

sudo apt-get install git wget ffmpeg python3-dev python3-setuptools \
    python3-requests python3-lxml
git clone https://github.com/aajanki/yle-dl.git
cd yle-dl
python3 setup.py install --user
```


## Debian 8 (Jessie)/Ubuntu 15.10 or older

```
# If you have installed a previous version globally (without the
# --user switch in the pip install command), remove the globally
# installed version first:
sudo pip uninstall yle-dl

sudo apt-get install wget libav-tools python-dev python-setuptools \
     python-pip python-requests python-lxml
pip install --user pyOpenSSL ndg-httpsclient pyasn1
pip install --user --upgrade yle-dl
```

(You may get prompted to upgrade pip. However, it is not necessary to
upgrade pip for installing yle-dl.)

### Installing from source code on Debian 8/Ubuntu 15.10 or older

```
# If you have installed a previous version globally (without the
# --user switch in the pip install command), remove the globally
# installed version first:
sudo pip uninstall yle-dl

sudo apt-get install git wget libav-tools python-dev \
    python-setuptools python-requests python-lxml
git clone https://github.com/aajanki/yle-dl.git
cd yle-dl
python setup.py install --user
```


## Gentoo

```
emerge -av yle-dl
```


## Mac OS X

```
brew install python
brew install wget
brew install ffmpeg
brew install yle-dl
```


## Windows 10

### Python

Download the latest Python 3 release from
https://www.python.org/downloads/windows/ and install it in C:\somepath\Python.

Append the following paths to the PATH environment variable in Control
Panel > System and security > System > Advanced system settings >
Environment Variables...:
```
C:\somepath\Python\Python36
C:\somepath\Python\Python37
C:\somepath\Python\Python36\Scripts
C:\somepath\Python\Python37\Scripts
%USERPROFILE%\AppData\Roaming\Python\Python36\Scripts
%USERPROFILE%\AppData\Roaming\Python\Python37\Scripts
```

### ffmpeg

Download the binary from
https://ffmpeg.org/download.html#build-windows. Select the latest
release build (not a nightly git build), Windows 64-bit, Static.
Extract the zip in `C:\somepath\ffmpeg`.

Append `C:\somepath\ffmpeg\bin` to the PATH environment variable.

### wget

Download the latest wget.exe from https://eternallybored.org/misc/wget
and copy it to C:\somepath\wget.

Append `C:\somepath\wget` to the PATH environment variable.

### yle-dl

```
pip install --user --upgrade yle-dl
```

Usage:

```
yle-dl --vfat https://areena.yle.fi/...
```


## Android

Install [Termux](https://termux.com/).

Run on the Termux terminal:
```
pkg install python make clang libgmp wget ffmpeg libxml2 libxml2-utils libxslt
pip install lxml yle-dl
```
